/*
cdrw.c - CD-ReWriter support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cdrw.h"

int cdrw_raw_usage(int argc,char *argv[])
{
#ifdef BACKUP
if(argcmp(argc,argv,"-help"))printf("%s\n",cdrw_TITLE);

printf(	"  -xraw         read/write MODE2_RAW/BIN IMAGE; $ROM=RAW_IMAGE\n"
	"		reads automatically when $ROM does not exist\n"
	"  -rawt         generate MODE2_RAW/BIN TOC file for cdrdao; $ROM=RAW_IMAGE\n"
);
	
//if(argcmp(argc,argv,"-help"))
{
}
#endif
	return(0);
}

int cdrw_raw_read(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096],buf3[4096];
long x=0;

  char *property;
#ifdef __DOS__
  strcpy(buf, "ucon64.cfg");
#else
  sprintf(buf, "%s%c.ucon64rc", getenv("HOME"), FILE_SEPARATOR);
#endif

  if (access(buf, F_OK) == -1)
  {
    printf("ERROR: %s does not exist\n", buf);
    return(-1);
  }

  property = getProperty(  buf
                          , "cdrw_raw_read"
                          , buf2
                          , "cdrdao read-cd --read-raw --device 0,0,0 --driver generic-mmc-raw --datafile"
                       );        // buf2 also contains property value


  strcpy(buf3,rom->rom);
  newext(buf3,".TOC");
  sprintf(buf, "%s \"%s\" \"%s\"", buf2, rom->rom,filebackup(buf3));
/*
  for (x = 0; x < rom->argc; x++)
  {
    if (strdcmp(rom->argv[x], "-xraw") && strdcmp(rom->argv[x], getarg(rom->argc,rom->argv,ucon64_NAME)) &&
        strdcmp(rom->argv[x], rom->file))
    {
      sprintf(buf2, ((!strdcmp(rom->argv[x], rom->rom)) ? " \"%s\"" : ""), rom->argv[x]);
      strcat(buf, buf2);
    }
  }
*/
  printf("%s\n", buf);
  fflush(stdout);
  sync();

  x = system(buf);
#ifndef __DOS__
  x >>= 8;                                      // the exit code is coded in bits 8-15
#endif                                          //  (that is, under Linux & BeOS)

#if 1
  // Snes9x (Linux) for example returns a non-zero value on a normal exit (3)...

  // under WinDOS, system() immediately returns with exit code 0 when starting
  //  a Windows executable (as if a fork() happened) it also returns 0 when the
  //  exe could not be started
  if (x != 127 && x != -1 && x != 0)    // 127 && -1 are system() errors, rest are exit codes
  {
    return(x);
  }
#endif
#endif /* BACKUP */
return(0);
}


int cdrw_raw_write(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096],buf3[4096];
long x=0;

  char *property;
#ifdef __DOS__
  strcpy(buf, "ucon64.cfg");
#else
  sprintf(buf, "%s%c.ucon64rc", getenv("HOME"), FILE_SEPARATOR);
#endif

  if (access(buf, F_OK) == -1)
  {
    printf("ERROR: %s does not exist\n", buf);
    return(-1);
  }

  property = getProperty(  buf
                          , "cdrw_raw_write"
                          , buf2
                          , "cdrdao write --eject --device 0,0,0 --driver generic-mmc"
                       );        // buf2 also contains property value

  strcpy(buf3,rom->rom);
  newext(buf3,".TOC");
  if(access(buf3, F_OK) == -1)
  {
  	cdrw_raw_mktoc(rom);
  }
  sprintf(buf, "%s \"%s\"", buf2,filebackup(buf3));
/*

  for (x = 0; x < rom->argc; x++)
  {
    if (strdcmp(rom->argv[x], "-xraw") && strdcmp(rom->argv[x], getarg(rom->argc,rom->argv,ucon64_NAME)) &&
        strdcmp(rom->argv[x], rom->file))
    {
      sprintf(buf2, ((!strdcmp(rom->argv[x], rom->rom)) ? " \"%s\"" : ""), rom->argv[x]);
      strcat(buf, buf2);
    }
  }
*/
  printf("%s\n", buf);
  fflush(stdout);
  sync();

  x = system(buf);
#ifndef __DOS__
  x >>= 8;                                      // the exit code is coded in bits 8-15
#endif                                          //  (that is, under Linux & BeOS)

#if 1
  // Snes9x (Linux) for example returns a non-zero value on a normal exit (3)...

  // under WinDOS, system() immediately returns with exit code 0 when starting
  //  a Windows executable (as if a fork() happened) it also returns 0 when the
  //  exe could not be started
  if (x != 127 && x != -1 && x != 0)    // 127 && -1 are system() errors, rest are exit codes
  {
    return(x);
  }
#endif

#endif /* BACKUP */
return(0);
}

int cdrw_raw_mktoc(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096];
FILE *fh;
int result;

    sprintf(buf,
"CD_ROM_XA\n"
"\n"
"\n"
"// Track 1\n"
"TRACK MODE2_RAW\n"
"NO COPY\n"
"DATAFILE \"%s\" %ld// length in bytes: %ld\n"
,rom->rom
,quickftell(rom->rom)
,quickftell(rom->rom)
);
    printf("%s\n",buf);

    strcpy(buf2,rom->rom);
    newext(buf2,".TOC");

    if( !( fh=fopen(buf2 ,"wb" ) ) )return(-1);
    result=fputs(buf,fh);
    fclose(fh);


    return(result);
#else 
  return(0);
#endif /* BACKUP */

}









int cdrw_iso_usage(int argc,char *argv[])
{
#ifdef BACKUP

//char buf[4096];

if(argcmp(argc,argv,"-help"))printf("%s\n",cdrw_TITLE);

printf(	"  -xiso         read/write ISO9660 IMAGE; $ROM=ISO_IMAGE\n"
	"		reads automatically when $ROM does not exist\n"
	"  -isot         generate ISO9660 TOC file for cdrdao; $ROM=ISO_IMAGE\n"
);
	
//if(argcmp(argc,argv,"-help"))
{
}
#endif /* BACKUP */
	return(0);
}

int cdrw_iso_read(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096],buf3[4096];
long x=0;

  char *property;
#ifdef __DOS__
  strcpy(buf, "ucon64.cfg");
#else
  sprintf(buf, "%s%c.ucon64rc", getenv("HOME"), FILE_SEPARATOR);
#endif

  if (access(buf, F_OK) == -1)
  {
    printf("ERROR: %s does not exist\n", buf);
    return(-1);
  }

  property = getProperty(  buf
                          , "cdrw_iso_read"
                          , buf2
                          , "cdrdao read-cd --read-raw --device 0,0,0 --driver generic-mmc-raw --datafile"
                       );        // buf2 also contains property value


  strcpy(buf3,rom->rom);
  newext(buf3,".TOC");
  sprintf(buf, "%s \"%s\" \"%s\"", buf2, rom->rom,filebackup(buf3));
/*
  for (x = 0; x < rom->argc; x++)
  {
    if (strdcmp(rom->argv[x], "-xiso") && strdcmp(rom->argv[x], getarg(rom->argc,rom->argv,ucon64_NAME)) &&
        strdcmp(rom->argv[x], rom->file))
    {
      sprintf(buf2, ((!strdcmp(rom->argv[x], rom->rom)) ? " \"%s\"" : ""), rom->argv[x]);
      strcat(buf, buf2);
    }
  }
*/
  printf("%s\n", buf);
  fflush(stdout);
  sync();

  x = system(buf);
#ifndef __DOS__
  x >>= 8;                                      // the exit code is coded in bits 8-15
#endif                                          //  (that is, under Linux & BeOS)

#if 1
  // Snes9x (Linux) for example returns a non-zero value on a normal exit (3)...

  // under WinDOS, system() immediately returns with exit code 0 when starting
  //  a Windows executable (as if a fork() happened) it also returns 0 when the
  //  exe could not be started
  if (x != 127 && x != -1 && x != 0)    // 127 && -1 are system() errors, rest are exit codes
  {
    return(x);
  }
#endif

#endif /* BACKUP */
return(0);
}


int cdrw_iso_write(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096],buf3[4096];
long x=0;

  char *property;
#ifdef __DOS__
  strcpy(buf, "ucon64.cfg");
#else
  sprintf(buf, "%s%c.ucon64rc", getenv("HOME"), FILE_SEPARATOR);
#endif

  if (access(buf, F_OK) == -1)
  {
    printf("ERROR: %s does not exist\n", buf);
    return(-1);
  }

  property = getProperty(  buf
                          , "cdrw_iso_write"
                          , buf2
                          , "cdrdao write --eject --device 0,0,0 --driver generic-mmc"
                       );        // buf2 also contains property value

  strcpy(buf3,rom->rom);
  newext(buf3,".TOC");
  if(access(buf3, F_OK) == -1)
  {
  	cdrw_iso_mktoc(rom);
  }
  sprintf(buf, "%s \"%s\"", buf2,filebackup(buf3));
/*

  for (x = 0; x < rom->argc; x++)
  {
    if (strdcmp(rom->argv[x], "-xiso") && strdcmp(rom->argv[x], getarg(rom->argc,rom->argv,ucon64_NAME)) &&
        strdcmp(rom->argv[x], rom->file))
    {
      sprintf(buf2, ((!strdcmp(rom->argv[x], rom->rom)) ? " \"%s\"" : ""), rom->argv[x]);
      strcat(buf, buf2);
    }
  }
*/
  printf("%s\n", buf);
  fflush(stdout);
  sync();

  x = system(buf);
#ifndef __DOS__
  x >>= 8;                                      // the exit code is coded in bits 8-15
#endif                                          //  (that is, under Linux & BeOS)

#if 1
  // Snes9x (Linux) for example returns a non-zero value on a normal exit (3)...

  // under WinDOS, system() immediately returns with exit code 0 when starting
  //  a Windows executable (as if a fork() happened) it also returns 0 when the
  //  exe could not be started
  if (x != 127 && x != -1 && x != 0)    // 127 && -1 are system() errors, rest are exit codes
  {
    return(x);
  }
#endif

#endif /* BACKUP */
return(0);
}




int cdrw_iso_mktoc(struct ucon64_ *rom)
{
#ifdef BACKUP
char buf[4096],buf2[4096];
FILE *fh;
int result;

    sprintf(buf,
"CD_ROM\n"
"\n"
"\n"
"// Track 1\n"
"TRACK MODE1\n"
"NO COPY\n"
"DATAFILE \"%s\" %ld// length in bytes: %ld\n"
,rom->rom
,quickftell(rom->rom)
,quickftell(rom->rom)
);
    printf("%s\n",buf);

    strcpy(buf2,rom->rom);
    newext(buf2,".TOC");

    if( !( fh=fopen(buf2 ,"wb" ) ) )return(-1);
    result=fputs(buf,fh);
    fclose(fh);

    return(result);
#else
  return(0);
#endif /* BACKUP */
}


/*

  1. Installing the CD-Writer

  For the average Linux user this is not a problem at all. There's just
  something special you should take care of: Linux does not support
  ATAPI-drives directly, you have to connect such devices via the SCSI
  emulation driver which tells the system it is a SCSI device. If you use a 2.2
  kernel up to version 2.2.9 this might be a bit problematic. There's no need
  for me to explain the whole procedure, because Winfried Trmper did this
  already in his CD-Writing HOWTO. Get it to install your drive properly.

  2. Used programs

  Usually you make a 1:1 copy of a cd-rom using dd to generate an image on the
  harddisk and burn this ISO 9660 image with cdrecord or cdwrite to the
  cd-recordable (This procedure is also described in the CD-Writing HOWTO).
  When copying Playstation-CD's this does not work because of two reasons: Most
  Playstation-CD's contain one or more audio tracks in addition to the data
  track which cannot be ripped off using dd, and the data track itself is
  written in mode 2 which dd can't handle either.

  The solution for the problems is cdrdao. This program makes it possible to
  read a cd-rom in raw mode (which means the whole 2352 bytes of a sector),
  doesn't matter whether it contains a data track in mode 1, 2 or even audio
  tracks. Like CDRWIN under Windows it creates two files when making an image
  to harddisk. One contains the raw data of a CD, the other one contains a
  description how the data should be written on the cd-recordable. Using this
  two files cdrdao is able to make a 1:1 copy of a psx-cd, if it doesn't
  contain a copy protection.

  If it does you have to patch the image file before burning of course. This is
  possible under Linux because of two circumstances: cdrdao stores the
  description data of an image into a separate file just like CDRWIN and writes
  only the contents of the CD into the image file. This means the image file
  created by cdrdao is identical to CDRWIN. And because the program used to
  apply the patches (ApplyPPF) is a dos binary it is no problem to run it in
  the dos-emulator dosemu.

  Recently Paradox have published the source code of ApplyPPF. The package
  contains already a pre-compiled version for the most common Unfixes, so you
  don't need to run dosemu anymore and there should be no problems left to
  patch an image under Linux.

  3. Handling

  3.1. Creating an image file of a Playstation-CD

  cdrdao supports all cd-rom and CD-r/w which are compliant to the mmc-
  standard. This includes most devices build from 1999 on. To preserve the
  writer try first to use the cd-rom for reading in the image. But if cdrdao
  displays "Padding with zero sectors..." or just freezes while reading you
  should cancel pressing CTRL-C and use the writer to read. The following shows
  how to invoke cdrdao for reading in an image:

  cdrdao read-cd --read-raw --datafile [filename.bin] --device
  [bus,id,lun] --driver generic-mmc-raw [filename.toc]

  [filename.bin] - The actual image file
  [bus,id,lun]- The SCSI-address of the used device
  [filename.toc] - The description file (Table Of Contents)

  Example:

  cdrdao read-cd --read-raw --datafile gta2.bin --device 0,1,0
  -- driver generic-mmc-raw gta2.toc

  If you don't have to patch you might want to continue reading at chapter 3.3.

  3.2. Patching the image file.

  First the system administrator has to unpack the ApplyPPF package and install
  the pre-compiled binary into a proper place on the system (e.g.
  /usr/local/bin). If the pre-compiled binaries doesn't match your system
  compile one. Don't forget to allow execution of ApplyPPF for all users
  afterwards (chmod +x /usr/local/bin/applyppf).

  Those who want to try dosemu and the dos version of ApplyPPF should start
  with the install-documentation of dosemu. Mainly this is handled by two
  scripts, setup-dosemu and setup-hdimage. When creating a hd-image it is
  better to use a start disk as source because when using the windows partition
  the boot menu always shows up when booting. Using lredir, which is included
  in the dosemu-package, you can mount your Linux partitions into dosemu and
  apply the patch.

  Syntax:

  applyppf filename.bin filename.ppf

  Example:

  applyppf gta2.bin bad-gta2.ppf

  ApplyPPF displays a short message if the patching process was successful.

  3.3. Writing the image file

  Invoke cdrdao as follows:

  cdrdao write --eject --speed [num] --device [bus,id,lun] --driver generic-mmc [filename.toc]

  Example:

  cdrdao write --eject --speed 4 --device 0,1,0 --driver generic-mmc
  gta2.toc

  That's all.

  4. Printing a cover

  Everybody who takes care of a nice cover does not need to use Windows, too.
  If you have to edit the cover before printing it (e.g. to shrink the left and
  right parts of the inlay to fit into a standard jewel-case) use the famous
  gimp. Printing with gimp is a bit problematic because you can't set the
  actual print size. Use xv for this purpose.

  But printing with gimp is possible. All you have to do is calculate the
  picture size in pixels:

  Front-cover
  Width and height in pixels = (12cm / 2.54) * dpi

  Back-inlay
  Width in pixels = (15cm / 2.54) * dpi
  Height in pixels = (11.8cm / 2.54) * dpi

  The brackets convert the cm-unit into inches and are multiplied with the
  desired resolution. The result is the needed picture size in pixels. An
  example for a color inkjet printer and 300 dpi resolution:

  Front-cover
  (12cm / 2.54) * 300 = 1417
  Picture size = 1417 x 1417 pixels

  Back-inlay
  (15cm / 2.54) * 300 = 1771
  (11.8cm / 2.54) * 300 = 1393
  Picture size = 1771 x 1393 pixels.

  When printing select ppi for scaling and set the resolution (in the example
  it was 300). A configured printer should then print the cover in the right
  size.

  5. Other playstation-software for Linux

  If this all is not enough there are many more programs for Linux to
  experiment with your PlayStation. Take a look at freshmeat.net and search for
  the keyword "Playstation".

*/
