/*
dc.c - Dreamcast support for uCON64

written by 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "dc.h"

#include "../patch/ppf.h"
#include "../patch/xps.h"

#include "../backup/cdrw.h"

int dc_init(struct ucon64_ *rom)
{
  rom->console=ucon64_DC;

  if(!argcmp(rom->argc,rom->argv,"-dc"))
  {
    rom->console=ucon64_UNKNOWN;
    return(-1);
  }

  strcpy(rom->title,dc_TITLE);
/*
  rom->header_start = psx_RAW_HEADER_START;

  if(argcmp(rom->argc,rom->argv,"-iso"))rom->header_start = psx_ISO_HEADER_START;
  if(argcmp(rom->argc,rom->argv,"-raw"))rom->header_start = psx_RAW_HEADER_START;
  rom->header_len = psx_HEADER_LEN;

  quickfread(rom->header,rom->header_start,rom->header_len,rom->rom);
  quickfread(&toc,rom->header_start,sizeof(struct iso_primary_descriptor),rom->rom);
*/
  sprintf(rom->copier,"%s",cdrw_TITLE);
/*
  strcpy(rom->name,toc.volume_id);
  strcpy(rom->manufacturer,toc.publisher_id);
//  strcpy(rom->country,
//  strcpy(rom->misc,"");
//  strcpy(rom->misc,
*/
  return(0);
}


int dc_usage(int argc,char *argv[])
{
printf("%s\n"
	"  -dc		force recognition; NEEDED\n"
//	"  -iso		force image is ISO9660\n"
//	"  -raw		force image is MODE2_RAW/BIN\n"
	"  *		show info (default); ONLY $ROM=ISO_IMAGE\n"
//        "TODO:  -ip	extract IP.BIN; $ROM=RAW_IMAGE\n"//from DJ3 andor Nero?
        "TODO:  -cdi2i	convert DiscJuggler3/CDI IMAGE to ISO9660; $ROM=CDI_IMAGE\n"
//        "               ISO9660 backups need a BootCD\n"
//        "TODO:  -n2i	convert Nero IMAGE to ISO9660; $ROM=NERO_IMAGE\n"
  ,dc_TITLE
);

  ppf_usage( argc, argv );
  xps_usage( argc, argv );

#ifdef CD
  cdrw_iso_usage(argc,argv);

//                ucon64 -dc -xcdao <IMAGE> currently works only for backups
//                                which need the Utopia BootCD
                                
#endif

printf("\n");

return(0);
}

/*

int ip0000(char *dev,char *name)
{
char buffer[2048];
        FILE *fp;
        

typedef struct ISODR
{
	struct ISODR *next;
	char *path;
	struct iso_directory_record isodr;
} ISODR;
#define ISODR_EXTRA (sizeof(struct ISODR*)+sizeof(char*)+1)

enum {
	ISODR_FLAG_ISFILE=0,
	ISODR_FLAG_ISDIR=2
};

typedef struct
{
	struct ISODR *ISODR;
	struct ISODR *isodrtail;
	struct ISODR *isodr;
	struct cdrom_tochdr toc;
	struct cdrom_tocentry toce;
	struct cdrom_mcn mcn;
	struct cdrom_multisession ms;
	struct cdrom_msf msf;
	struct iso_directory_record *isodrptr;
	struct iso_primary_descriptor *isopd;
	unsigned long trackoffset, start, end;
	int session;
	int fd;
	u_char data[CD_FRAMESIZE_RAW], isopddata[CD_FRAMESIZE_RAW];
} ISO9660;
ISO9660 iso;
int i;
char track=0;
if((iso.fd=open(dev,O_RDONLY))==-1)return(-1);


	if(ioctl(iso.fd,CDROMREADTOCHDR,&iso.toc)==-1)return(-1);
	memset(&iso.toce,0,sizeof(iso.toce));
	iso.toce.cdte_format=CDROM_MSF;
	for(i=iso.toc.cdth_trk0; i<=iso.toc.cdth_trk1; i++)
	{
		iso.toce.cdte_track=i;
		if(ioctl(iso.fd,CDROMREADTOCENTRY,&iso.toce)==-1)
		{
			close(iso.fd);
			return(-1);
		}
		switch(iso.toce.cdte_format)
		{
			case CDROM_MSF:
				if(i==iso.toc.cdth_trk0+track)
					iso.trackoffset=msf2frame(&iso.toce.cdte_addr.msf);
				break;
			case CDROM_LBA:
				break;
		}
	}




	frame2msf(iso.trackoffset+16,&iso.msf);
	memcpy(iso.isopddata,&iso.msf,sizeof(iso.msf));
	if(ioctl(iso.fd,CDROMREADRAW,iso.isopddata,iso.isopddata) < 0)
	{
		close(iso.fd);
		return(-1);
	}
	iso.isopd=(struct iso_primary_descriptor*)(&iso.isopddata[CD_SYNC_SIZE+CD_HEAD_SIZE+CD_SUBHEAD_SIZE]);

fhexdump((char *)iso.isopd,0,256);
        close(iso.fd);
        
//here the buffer is filled...

strncpy(buffer,(char *)iso.isopd,sizeof(buffer));
if(buffer[0]!='S')return(-1); //no dreamcast gc-rom
if(!(fp=fopen("ip0000.bin","w")))return(-1);
fwrite(buffer,256,1,fp); //Only save the first 256 Bytes wich is the IP
fclose(fp);
                                
//        close(iso.fd);
//cdinfo(dev);
//	exit(0);
	return(0);
}
*/


#ifdef CD
  int dc_isot(struct ucon64_ *rom)
  {
    return( cdrw_iso_mktoc(rom) );
  }

  int dc_xiso(struct ucon64_ *rom)
  {
    return( (!access(rom->rom, F_OK)) ? cdrw_iso_write(rom) : cdrw_iso_read(rom) );
  }
#endif
