/*
genesis.h - Sega Genesis/Mega Drive support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef GENESIS_H
#define GENESIS_H
#include "../ucon64.h"

int genesis_1991(struct ucon64_ *rom);
int genesis_chk(struct ucon64_ *rom);
int genesis_chksum(struct ucon64_ *rom);
int genesis_ggd(struct ucon64_ *rom);
int genesis_gge(struct ucon64_ *rom);
int genesis_j(struct ucon64_ *rom);
int genesis_mgd(struct ucon64_ *rom);
int genesis_n(struct ucon64_ *rom);
int genesis_n2(struct ucon64_ *rom);
int genesis_p(struct ucon64_ *rom);
int genesis_s(struct ucon64_ *rom);
int genesis_smd(struct ucon64_ *rom);
int genesis_smds(struct ucon64_ *rom);
int genesis_xsmd(struct ucon64_ *rom);
int genesis_xsmds(struct ucon64_ *rom);

int genesis_init(struct ucon64_ *rom);
int swap8192gen(struct ucon64_ *rom);
int genesis_chksum(struct ucon64_ *rom);
int genesis_readheader(struct ucon64_ *rom);
int genesis_writeheader(struct ucon64_ *rom);
int genesis_join(struct ucon64_ *rom);

#define genesis_TITLE "Genesis/Sega Mega Drive/Sega CD/32X/Nomad\n1989/19XX/19XX SEGA http://www.sega.com"
#define genesis_TITLE1 "Genesis/Sega CD/32X/Nomad\n1989/19XX/19XX SEGA http://www.sega.com"
#define genesis_TITLE2 "Sega Mega Drive/Sega CD/32X/Nomad\n1989/19XX/19XX SEGA http://www.sega.com"

int genesis_usage(int argc, char *argv[]);

int genesis_rawt(struct ucon64_ *rom);
int genesis_xraw(struct ucon64_ *rom);

int load_smd_into(char *name,unsigned char *into);
int load_bin_into(char *name,unsigned char *into);
int load_rom_into(char *name,unsigned char *into);

int gameGenieDecodeMegadrive(const char *in, char *out);
int gameGenieEncodeMegadrive(const char *in, char *out);
#endif /* GENESIS_H */
