/*
jaguar.c - Atari Jaguar support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "jaguar.h"

#include "../backup/unknown_bu.h"
#include "../backup/unknown_bu512.h"

#include "../backup/cdrw.h"

#define jaguar_ROM_HEADER_START 0x400
#define jaguar_ROM_HEADER_LEN 16

int jaguar_init(struct ucon64_ *rom)
{
long x,y;

rom->console=ucon64_JAGUAR;

rom->buheader_len=0;
ucon64_dbsearch(rom);

if(rom->db_crc32==0)
{
/*	rom->buheader_len=unknown_bu512_HEADER_LEN;
	rom->current_crc32=fileCRC32(rom->rom,rom->buheader_len);

	ucon64_dbsearch(rom);

	if(rom->db_crc32==0)
*/	{

rom->buheader_len=0;

y=0;
for(x=0;x<12;x++)y+=quickfgetc(rom->rom,jaguar_ROM_HEADER_START+rom->buheader_len+x);
if(y!=0x0b0)
{
	rom->buheader_len=unknown_bu512_HEADER_LEN;

	y=0;
	for(x=0;x<12;x++)y+=quickfgetc(rom->rom,jaguar_ROM_HEADER_START+rom->buheader_len+x);
	if(y!=0x0b0)
	{
		if(!argcmp(rom->argc,rom->argv,"-jag"))
		{
			rom->console=ucon64_UNKNOWN;
			return(-1);
		}
	}
}
	}
}

  if(argcmp(rom->argc,rom->argv,"-hd"))rom->buheader_len=unknown_bu512_HEADER_LEN;
  if(argcmp(rom->argc,rom->argv,"-nhd"))rom->buheader_len=0;

  strcpy(rom->title,jaguar_TITLE);
  strcpy(rom->copier,(!rom->buheader_len) ?  unknown_bu_TITLE : unknown_bu512_TITLE );

  rom->header_start=jaguar_ROM_HEADER_START;
  rom->header_len=jaguar_ROM_HEADER_LEN;

  return(0);
}

int jaguar_usage(int argc,char *argv[])
{
printf("%s\n"
	"  -jag		force recognition\n"
	"  -hd		force ROM has header (+512 Bytes)\n"
	"  -nhd		force ROM has no header\n"
	"  *		show info (default)\n"
,jaguar_TITLE
);

#ifdef BACKUP
#endif

#ifdef CD
  cdrw_raw_usage(argc,argv);
#endif

printf("\n");

return(0);
}

#ifdef CD
  int jaguar_rawt(struct ucon64_ *rom)
  {
    return( cdrw_raw_mktoc(rom) );
  }

  int jaguar_xraw(struct ucon64_ *rom)
  {
    return( (!access(rom->rom, F_OK)) ? cdrw_raw_write(rom) : cdrw_raw_read(rom) );
  }
#endif
