/*
nes.c - Nintendo Entertainment System support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef NES_H
#define NES_H
#include "../ucon64.h"

#define nes_TITLE "Nintendo Entertainment System/NES\n1983 Nintendo http://www.nintendo.com"

int nes_fds(struct ucon64_ *rom);
int nes_fdsl(struct ucon64_ *rom);
int nes_fdslist(char *nes_diskimage);
int nes_ffe(struct ucon64_ *rom);
int nes_gg(struct ucon64_ *rom);
int nes_ggd(struct ucon64_ *rom);
int nes_gge(struct ucon64_ *rom);
int nes_ines(struct ucon64_ *rom);
int nes_ineshd(struct ucon64_ *rom);
int nes_j(struct ucon64_ *rom);
int nes_join(char *name);
int nes_pas(struct ucon64_ *rom);
int nes_s(struct ucon64_ *rom);
int nes_usage(int argc,char *argv[]);
int nes_init(struct ucon64_ *rom);


int gameGenieEncodeNES(const char *in, char *out);
int gameGenieDecodeNES(const char *in, char *out);
#endif /* NES_H */
