/*
ngp.c - NeoGeo Pocket support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)
                  2001 Gulliver


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "ngp.h"

#include "../backup/fpl.h"
#include "../backup/unknown_bu512.h"

#define neogeopocket_ROM_HEADER_START 0x0
#define neogeopocket_ROM_HEADER_LEN 48

int neogeopocket_init(struct ucon64_ *rom)
{
 char code_buffer[29];
 char title_buffer[12];
 char snk_code[]  ="COPYRIGHT BY SNK CORPORATION";
 char third_code[]=" LICENSED BY SNK CORPORATION";  

 char *producer = "Unknown";	 		 
 char *system = "Unknown";
	 
 char SNK[]="SNK";
 char THIRD[]="third party";
 char mono[]="monochrome";
 char color[]="color";
 char buf[4096];

  int tmp=0;
 
rom->console=ucon64_NEOGEOPOCKET;

rom->buheader_len=0;
ucon64_dbsearch(rom);

if(rom->db_crc32==0)
{
/*	rom->buheader_len=unknown_bu512_HEADER_LEN;
	rom->current_crc32=fileCRC32(rom->rom,rom->buheader_len);

	ucon64_dbsearch(rom);

	if(rom->db_crc32==0)
*/	{
		if(!argcmp(rom->argc,rom->argv,"-ngp"))
		{
                        rom->console=ucon64_UNKNOWN;
                        return(-1);
		}
	}
}

  if(argcmp(rom->argc,rom->argv,"-hd"))rom->buheader_len=unknown_bu512_HEADER_LEN;
  if(argcmp(rom->argc,rom->argv,"-nhd"))rom->buheader_len=0;

  strcpy(rom->title,neogeopocket_TITLE);
  strcpy(rom->copier,(!rom->buheader_len) ? fpl_TITLE : unknown_bu512_TITLE);

  rom->header_start=neogeopocket_ROM_HEADER_START;
  rom->header_len=neogeopocket_ROM_HEADER_LEN;
  quickfread(rom->header,rom->header_start,rom->header_len,rom->rom);

  quickfread(title_buffer,0x24+rom->buheader_len,12,rom->rom);
  strcpy(rom->name,title_buffer);

  quickfread(code_buffer,0+rom->buheader_len,29,rom->rom);
  if ( (strcmp(code_buffer,snk_code)) == 0 ) producer=SNK;
  else if ( (strcmp(code_buffer,third_code)) == 0 ) producer=THIRD;
  strcpy(rom->manufacturer,producer);

  strcpy(rom->misc,"");


  tmp=quickfgetc(rom->rom,0x23+rom->buheader_len);
  if (tmp == 0x00) system=mono;
  else if (tmp == 0x10) system=color;
  sprintf(buf,"Mode: %s",system);
  strcat(rom->misc,buf);

  return(0);
}



int neogeopocket_usage(int argc,char *argv[])
{
printf("%s\n"
	"  -ngp		force recognition\n"
	"  *		show info (default)\n"
,neogeopocket_TITLE
);

#ifdef BACKUP
fpl_usage(argc,argv);
#endif

printf("\n");

return(0);
}
