/*
ucon64_db.c - a simple database for ROMs of old consoles and with no internal
info header for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "ucon64.h"
#include "ucon64_db.h"

struct ucon64_DB
{
	unsigned long current_crc32;	//standart current_crc32 checksum of the rom
	long console;	//integer for the console system

	char *name;	//name of the ROM
	long manufacturer;	//manufacturer of the ROM as integer
	long country;	//country of the ROM as integer
	char *misc;	//some miscellaneous information about the ROM
} db[] = {
{0x00000000,ucon64_UNKNOWN,"Unknown ROM",0,0,"edit ucon64_db.c and recompile"}
#ifdef DB
,
	#include "db.h"
#endif
};

struct ucon64_ *ucon64_dbsearch(	struct ucon64_ *rom	)
{
unsigned long dbsize,dbpos=0,dbmin=0,dbmax=0;

char *ucon64_MANUFACTURER[] = {
"Unknown manufacturer"	//0
,"ACCOLADE"
,"AICOM"
,"ARC"
,"ARTMIC"
,"ASCII"	//5
,"ASCII/Nexoft"
,"ASK KODANSHA"
,"ASMIK"
,"ATLUS"
,"AZUMA"	//10
,"Absolute Entertainment"
,"Absolute"
,"Acclaim"
,"Accolade"
,"Activision"	//15
,"Altron"
,"American Sammy"
,"American Softworks"
,"Arcade Zone"
,"Asmik"	//20
,"Athena"
,"Atlus"
,"BIG DON"
,"BIGCLUB"
,"BIT2"	//25
,"BULLET PROOF"
,"Bandai"
,"Banpresto"
,"Beam Software/Extreme"
,"Bec"	//30
,"Bitmap Brothers/Mindscape"
,"Broderbund"
,"Bullet-Proof Software"
,"CAPCOM"
,"CINEMAWARE"	//35
,"COBRA Team"
,"COCONUTS"
,"CREAM"
,"Capcom"
,"Carrozzeria"	//40
,"Character Soft"
,"Chun Soft"
,"Coconuts"
,"Culture Brain"
,"Cybersoft"	//45
,"DATA EAST"
,"DEKA"
,"DISNEY"
,"Data East"
,"Datam Polystar"	//50
,"Davidson"
,"Disco/Taito"
,"Dynamic"
,"Electro Brain"
,"ElectroBrain"	//55
,"Electronic Arts"
,"Elite"
,"Empire Software"
,"Enix"
,"Epoch"	//60
,"FACE"
,"FCI/Pony Canyon"
,"FUJITV"
,"FUN PROJECT"
,"Falcom"	//65
,"GAMES EXPRESS"
,"Gametek"
,"Gremlin Graphics"
,"HAL"
,"HOMEDATA"	//70
,"HOT-B"
,"HUDSON V1"
,"HUDSON V2"
,"HUDSON"
,"HUMAN"	//75
,"Halken"
,"Hect"
,"Hi Tech Entertainment"
,"Hori"
,"Hudson Soft"	//80
,"Human"
,"Human/Field"
,"I'Max"
,"ICOM"
,"IGS"	//85
,"IMAGE"
,"IMAX"
,"INTEC"
,"IREM"
,"Imagesoft"	//90
,"Imagineer"
,"Imagineer-Zoom"
,"Infogrames"
,"Interplay"
,"Irem"	//95
,"JVC"
,"Jaleco"
,"K. Amusement Leasing Co."
,"KANEKO"
,"KOEI"	//100
,"KONAMI"
,"KSS"
,"Kaneco"
,"Kawada"
,"Kemco"	//105
,"King Records"
,"Konami"
,"LASER SOFT"
,"LJN"
,"LORICIEL"	//110
,"Laserbeam"
,"Left Field Entertainment"
,"Loriciel"
,"Loriciel/Electro Brain"
,"Lozc"	//115
,"LucasArts"
,"MAGAE CHIP VERSION"
,"MANLEY & ASSOCIATES"
,"MASYNYA & NCS"
,"MASYNYA"	//120
,"MEDIA RINGS"
,"Magifact"
,"Malibu Games"
,"Maxis*"
,"Meldac"	//125
,"Micro World"
,"Microprose"
,"Mindscape"
,"Misawa"
,"Motown Software"	//130
,"NAMCO"
,"NATSUME"
,"NATSUME"
,"NAXAT SOFT"
,"NAXAT"	//135
,"NCS"
,"NEC / HUDSON"
,"NEC AVENUE & TAITO"
,"NEC AVENUE"
,"NEC HOME ELECTRONICS"	//140
,"NEC"
,"NHK"
,"NICHIBUTSU"
,"NIHON BUSSAN"
,"NTVIC"	//145
,"Namco"
,"Namcot"
,"Natsume"
,"Naxat"
,"Nichibutsu"	//150
,"Nintendo"
,"Ocean"
,"Open System"
,"Origin/FCI/Pony Canyon"
,"PACK-IN-VIDEO"	//155
,"PALSOFT"
,"POW"
,"PSYGNOSYS"
,"Pack-In-Video"
,"Palcom/Ultra"	//160
,"Park Place"
,"Parker Brothers"
,"Pony Canyon"
,"Quest"
,"RANDOM HOUSE"	//165
,"Rage Software"
,"Raya Systems"
,"Renovation Products*"
,"SALIO"
,"SEGA"	//170
,"SEIBU KAIHATSU"
,"SGX"
,"SPECTRUM HOLOBYTE"
,"SSL"
,"STORM*"	//175
,"SUMMER PROJECT"
,"SUNRISE"
,"SUNSOFT"
,"Sammy"
,"Seika"	//180
,"Seta Co.,Ltd."
,"Sigma*"
,"Sofel"
,"Sony Imagesoft"
,"Sony Music Entertainment"	//185
,"Sotsu Agency/Sunrise"
,"Spectrum Holobyte"
,"Square"
,"SquareSoft"
,"Starfish"	//190
,"SunSoft"
,"Sunsoft"
,"System 3"
,"T&Esoft"
,"T*HQ"	//195
,"T.I.M."
,"TAISANG VERSION"
,"TAITO 384K STYLE"
,"TAITO"
,"TAKARA"	//200
,"TECHNOS"
,"TELENET"
,"TENGEN"
,"THE HU62680 TEAM"
,"TITUS"	//205
,"TOEI Animation"
,"TONKIN HOUSE"
,"Taito"
,"Takara"
,"TecMagik"	//210
,"Technos Japan"
,"Technos"
,"Tecmo Products"
,"Tecmo"
,"Teichio"	//215
,"Telenet"
,"Titus"
,"Toho"
,"Tokuma Soft"
,"Tomy"		//220
,"Tonkin House"
,"Tonkinhouse"
,"Toshiba EMI"
,"Towachiki"
,"Tradewest"	//225
,"Triffix Entertainment"
,"Triffix"
,"Tsuburava"
,"U.S. Gold"
,"UNI POST"	//230
,"UPL"
,"Ubi Soft"
,"VAP"
,"VICTOR"
,"VIDEO SYSTEM"	//235
,"Varie"
,"Viacom New Media"
,"Vic Tokai"
,"Video System"
,"Virgin Games"	//240
,"Virgin Interactive Entertainment"
,"Virgin"
,"Visit Co.,Ltd."
,"WOLF TEAM,"
,"Yanoman"	//245
,"Yutaka"
,"Zamuse"
,"Westone"
,"Extreme"
,"Kaneko"	//250
,"Game Arts"
,"Tengen"
,"Psygnosis"
,"CRI"
,"Domark"	//255
,"Codemasters"
,"Spectrum HoloByte"
};

char *ucon64_COUNTRY[] = {
"Unknown country"	//0
,"Asia"
,"Australia"
,"Brazil"
,"Denmark"
,"Europe"	//5
,"Europe, Australia, Oceania and Asia"
,"Finland"
,"France"
,"France, German, Dutch"
,"Germany"	//10
,"Germany, Austria and Switzerland"
,"Holland"
,"Hong Kong and China"
,"Indonesia"
,"Italy"	//15
,"Japan"
,"Korea"
,"Spain"
,"Sweden"
,"U.S.A."	//20
};

dbsize = ucon64_dbsize( ucon64_UNKNOWN );

dbmax=dbsize;
dbpos=(dbsize/2);


//	binary search
while
(
	dbpos != dbmax && dbpos != dbmin &&
	(rom->current_crc32)/512 != (db[dbpos].current_crc32)/512
//division through 512 for tolerance
)
{
	if( rom->current_crc32 > ( db[dbpos].current_crc32 ) )
	{
		dbmin=dbpos;
		dbpos+=((dbmax-dbpos)/2);
	}
	else
	{
		dbmax=dbpos;
		dbpos-=((dbpos-dbmin)/2);
	}
}


if( 
	( rom->console != ucon64_UNKNOWN &&
	db[dbpos].console != rom->console )
	 ||
	(rom->current_crc32)/512 !=
	(db[dbpos].current_crc32)/512
) dbpos = 0;

rom->db_crc32=db[dbpos].current_crc32;

if( rom->console == ucon64_UNKNOWN )rom->console = db[dbpos].console;

strcpy(rom->name,db[dbpos].name);
rom->name_len=strlen(rom->name);

strcpy(rom->manufacturer,ucon64_MANUFACTURER[
    (db[dbpos].manufacturer > ucon64_DBMANUFACTURERSIZE) ? 0 :
       db[dbpos].manufacturer ]);
rom->manufacturer_len=strlen(rom->manufacturer);

strcpy(rom->country,ucon64_COUNTRY[
    (db[dbpos].country > ucon64_DBCOUNTRYSIZE) ? 0 :
       db[dbpos].country ]);
rom->country_len=strlen(rom->country);

strcpy(rom->misc,db[dbpos].misc);

return(rom);
}

int ucon64_dbview( long console )
{
long dbpos,dbsize;

char *CONSOLE[]={
"ucon64_UNKNOWN"	//0
,"ucon64_GB"
,"ucon64_GENESIS"
,"ucon64_SMS"
,"ucon64_JAGUAR"
,"ucon64_LYNX"	//5
,"ucon64_N64"
,"ucon64_NEOGEO"
,"ucon64_NES"
,"ucon64_PCE"
,"ucon64_PSX"	//10
,"ucon64_PSX2"
,"ucon64_SNES"
,"ucon64_SATURN"
,"ucon64_DC"
,"ucon64_CD32"	//15
,"ucon64_CDI"
,"ucon64_REAL3DO"
,"ucon64_ATARI"
,"ucon64_SYSTEM16"
,"ucon64_NEOGEOPOCKET"	//20
,"ucon64_GBA"
,"ucon64_VECTREX"
,"ucon64_VIRTUALBOY"
,"ucon64_WONDERSWAN"
,"ucon64_COLECO"	//25
,"ucon64_INTELLI"
};

dbsize = ucon64_dbsize( ucon64_UNKNOWN );

for( dbpos = 0 ; dbpos < dbsize ; dbpos++)
{
  if(	db[dbpos].console == console ||
    console == ucon64_UNKNOWN )
  printf(
    ",{0x%08lx,%s,\"%s\",%ld,%ld,\"%s\"}\n"
    ,(unsigned long)db[dbpos].current_crc32
    ,CONSOLE[(db[dbpos].console > ucon64_DBCONSOLESIZE) ? 0 : db[dbpos].console]
    ,db[dbpos].name
    ,db[dbpos].manufacturer
    ,db[dbpos].country
    ,db[dbpos].misc
  );
}
	return(0);
}

long ucon64_dbsize( long console )
{
long dbpos,dbsize = 0;

if( console == ucon64_UNKNOWN )return( sizeof( db ) / sizeof( struct ucon64_DB ) );

for( dbpos = 0 ; dbpos < ( sizeof( db ) / sizeof( struct ucon64_DB ) ) ; dbpos++ )
{
	if( db[dbpos].console == console )dbsize++;
}
return(dbsize);
}
