/*
vboy.c - Nintendo Virtual Boy support for uCON64

written by 1999 - 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "vboy.h"

#include "../backup/unknown_bu.h"
#include "../backup/unknown_bu512.h"

#define virtualboy_ROM_HEADER_START 0x0
#define virtualboy_ROM_HEADER_LEN 0

int virtualboy_init(struct ucon64_ *rom)
{
rom->console=ucon64_VIRTUALBOY;

rom->buheader_len=0;
ucon64_dbsearch(rom);

if(rom->db_crc32==0)
{
/*	rom->buheader_len=unknown_bu512_HEADER_LEN;
	rom->current_crc32=fileCRC32(rom->rom,rom->buheader_len);

	ucon64_dbsearch(rom);

	if(rom->db_crc32==0)
*/	{
		if(!argcmp(rom->argc,rom->argv,"-vboy"))
		{
                        rom->console=ucon64_UNKNOWN;
                        return(-1);
		}
	}
}

  if(argcmp(rom->argc,rom->argv,"-hd"))rom->buheader_len=unknown_bu512_HEADER_LEN;
  if(argcmp(rom->argc,rom->argv,"-nhd"))rom->buheader_len=0;

  strcpy(rom->title,virtualboy_TITLE);
  strcpy(rom->copier,(!rom->buheader_len) ? unknown_bu_TITLE  : unknown_bu512_TITLE );

  return(0);
}


int virtualboy_usage(int argc,char *argv[])
{
printf("%s\n"
	"  -vboy		force recognition"
#ifndef DB
"; NEEDED"
#endif
	"\n  *		show info (default)\n"
	"\n"
,virtualboy_TITLE
);

return(0);
}
