/*
xbox.c - XBox support for uCON64

written by 2001 NoisyB (noisyb@gmx.net)


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "xbox.h"

#include "../patch/ppf.h"
#include "../patch/xps.h"
#include "../patch/pal4u.h"

#include "../backup/cdrw.h"

int xbox_init(struct ucon64_ *rom)
{
  rom->console=ucon64_XBOX;

  if(!argcmp(rom->argc,rom->argv,"-xbox"))
  {
    rom->console=ucon64_UNKNOWN;
    return(-1);
  }
  return(0);
}


int xbox_usage(int argc,char *argv[])
{
/*printf("%s\n"
	"  -xbox	force recognition; NEEDED"
	"\n  *		show info (default); $ROM=RAW_IMAGE or $ROM=ISO_IMAGE\n"
,xbox_TITLE
);


#ifdef CD
  cdrw_raw_usage(argc,argv);
  cdrw_iso_usage(argc,argv);
#endif

printf("\n");
*/
return(0);
}

#ifdef CD
  int xbox_rawt(struct ucon64_ *rom)
  {
    return( cdrw_raw_mktoc(rom) );
  }

  int xbox_xraw(struct ucon64_ *rom)
  {
    return( (!access(rom->rom, F_OK)) ? cdrw_raw_write(rom) : cdrw_raw_read(rom) );
  }

  int xbox_isot(struct ucon64_ *rom)
  {
    return( cdrw_iso_mktoc(rom) );
  }

  int xbox_xiso(struct ucon64_ *rom)
  {
    return( (!access(rom->rom, F_OK)) ? cdrw_iso_write(rom) : cdrw_iso_read(rom) );
  }
#endif
